searchNodes=[{"ref":"Mix.Tasks.Nerves.Gen.QemuScript.html","title":"Mix.Tasks.Nerves.Gen.QemuScript","type":"task","doc":"Generates a shell script for starting QEMU on a firmware image that uses nerves_system_x86_64. To use the generated script, first create the firmware image using: $ mix firmware.image [path/to/my_app.img] Place this image somewhere where it won&#39;t get overwritten. This image has a similar purpose to the MicroSD card, Flash memory or hard drive that a real target would use. Next, run this command and specify the path to the image. This path may be overridden when invoking the script. Example usage: $ mix nerves.gen.qemu_script [path/to/my_app.img] If the .img file isn&#39;t specified, it will default to the OTP application&#39;s name plus the .img extension. Options None"},{"ref":"Mix.Tasks.Nerves.Gen.QemuScript.html#run/1","title":"Mix.Tasks.Nerves.Gen.QemuScript.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"readme.html","title":"Generic x86_64 System","type":"extras","doc":"Generic x86_64 System This is the base Nerves System configuration for a generic x86_64 system. FeatureDescription CPUIntel Memory512 MB+ DRAM StorageHard disk/SSD/etc. (/dev/sda) Linux kernel4.19 IEx terminalDisplay - tty0 Hardware I/ONone EthernetYes Please contact us about this if you&#39;re really interested in it. We don&#39;t exercise it regularly except as a base for other x86_64 projects."},{"ref":"readme.html#using","title":"Generic x86_64 System - Using","type":"extras","doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=x86_64. See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems If you&#39;re new to Nerves, check out the nerves_init_gadget project for creating a starter project. It will get you started with the basics like bringing up networking, initializing the writable application data partition, and enabling ssh-based firmware updates. It&#39;s easiest to begin by using the wired Ethernet interface &#39;eth0&#39; and DHCP."},{"ref":"readme.html#root-disk-naming","title":"Generic x86_64 System - Root disk naming","type":"extras","doc":"If you have multiple SSDs, or other devices connected, it&#39;s possible that Linux will enumerate those devices in a nondeterministic order. This can be mitigated by using udev to populate the /dev/disks/by-* directories, but even this can be inconvenient when you just want to refer to the drive that provides the root filesystem. To address this, erlinit creates /dev/rootdisk0, /dev/rootdisk0p1, etc. and symlinks them to the expected devices. For example, if your root file system is on /dev/mmcblk0p1, you&#39;ll get a symlink from /dev/rootdisk0p1 to /dev/mmcblk0p1 and the whole disk will be /dev/rootdisk0. Similarly, if the root filesystem is on /dev/sdb1, you&#39;d still get /dev/rootdisk0p1 and /dev/rootdisk0 and they&#39;d by symlinked to /dev/sdb1 and /dev/sdb respectively."},{"ref":"readme.html#provisioning-devices","title":"Generic x86_64 System - Provisioning devices","type":"extras","doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store&#39;s Nerves.Runtime.KV.get/1 function. Keys used by this system are: KeyExample ValueDescription nerves_serial_number&quot;12345678&quot;By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Ethernet adapter&#39;s MAC address. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd(&quot;fw_setenv nerves_serial_number 12345678&quot;) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you&#39;re programming MicroSD cards using fwup, the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf. The default provisioning.conf will set the nerves_serial_number, if you override the location to this file, you will be responsible for setting this yourself."}]